unit uPattern;

interface

type

  TVisitor = class;           // forward declaration

  TVisited = class(TObject)
  public
    // This method is often called "Accept"
    procedure AcceptVisitFrom(Visitor: TVisitor); virtual; abstract;
  end;

  TVisitor = class(TObject)
  public
    // This method is often called "Visit"
    procedure AllowVisitorToDoSomethingTo(Visited: TVisited); virtual; abstract;
  end;

implementation

end.
